diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/scsi.c linux-2.4.22-ashuariadevel/drivers/scsi/scsi.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/scsi.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/scsi.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 2483,2489 ****
  		for (SDpnt = shpnt->host_queue; SDpnt; SDpnt = SDpnt->next) {
  			for (SCpnt = SDpnt->device_queue; SCpnt; SCpnt = SCpnt->next) {
  				/*  (0) h:c:t:l (dev sect nsect cnumsec sg) (ret all flg) (to/cmd to ito) cmd snse result %d %x      */
! 				printk(KERN_INFO "(%3d) %2d:%1d:%2d:%2d (%6s %4ld %4ld %4ld %4x %1d) (%1d %1d 0x%2x) (%4d %4d %4d) 0x%2.2x 0x%2.2x 0x%8.8x\n",
  				       i++,
  
  				       SCpnt->host->host_no,
--- 2483,2489 ----
  		for (SDpnt = shpnt->host_queue; SDpnt; SDpnt = SDpnt->next) {
  			for (SCpnt = SDpnt->device_queue; SCpnt; SCpnt = SCpnt->next) {
  				/*  (0) h:c:t:l (dev sect nsect cnumsec sg) (ret all flg) (to/cmd to ito) cmd snse result %d %x      */
! 				printk(KERN_INFO "(%3d) %2d:%1d:%2d:%2d (%6s %4lld %4ld %4ld %4x %1d) (%1d %1d 0x%2x) (%4d %4d %4d) 0x%2.2x 0x%2.2x 0x%8.8x\n",
  				       i++,
  
  				       SCpnt->host->host_no,
***************
*** 2492,2498 ****
  				       SCpnt->lun,
  
  				       kdevname(SCpnt->request.rq_dev),
! 				       SCpnt->request.sector,
  				       SCpnt->request.nr_sectors,
  				       SCpnt->request.current_nr_sectors,
  				       SCpnt->request.rq_status,
--- 2492,2498 ----
  				       SCpnt->lun,
  
  				       kdevname(SCpnt->request.rq_dev),
! 				       (unsigned long long)SCpnt->request.sector,
  				       SCpnt->request.nr_sectors,
  				       SCpnt->request.current_nr_sectors,
  				       SCpnt->request.rq_status,
***************
*** 2529,2538 ****
  					entry = queue_head->next;
  					do {
  						req = blkdev_entry_to_request(entry);
! 						printk("(%s %d %ld %ld %ld) ",
  						   kdevname(req->rq_dev),
  						       req->cmd,
! 						       req->sector,
  						       req->nr_sectors,
  						req->current_nr_sectors);
  					} while ((entry = entry->next) != queue_head);
--- 2529,2538 ----
  					entry = queue_head->next;
  					do {
  						req = blkdev_entry_to_request(entry);
! 						printk("(%s %d %llu %ld %ld) ",
  						   kdevname(req->rq_dev),
  						       req->cmd,
! 						       (unsigned long long)req->sector,
  						       req->nr_sectors,
  						req->current_nr_sectors);
  					} while ((entry = entry->next) != queue_head);
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/scsi_lib.c linux-2.4.22-ashuariadevel/drivers/scsi/scsi_lib.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/scsi_lib.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/scsi_lib.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 395,402 ****
  	req = &SCpnt->request;
  	req->errors = 0;
  	if (!uptodate) {
! 		printk(" I/O error: dev %s, sector %lu\n",
! 		       kdevname(req->rq_dev), req->sector);
  	}
  	do {
  		if ((bh = req->bh) != NULL) {
--- 395,402 ----
  	req = &SCpnt->request;
  	req->errors = 0;
  	if (!uptodate) {
! 		printk(" I/O error: dev %s, sector %llu\n",
! 		       kdevname(req->rq_dev), (unsigned long long)req->sector);
  	}
  	do {
  		if ((bh = req->bh) != NULL) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/sd.c linux-2.4.22-ashuariadevel/drivers/scsi/sd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/sd.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/sd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 91,97 ****
  
  static Scsi_Disk *rscsi_disks;
  static struct gendisk *sd_gendisks;
! static int *sd_sizes;
  static int *sd_blocksizes;
  static int *sd_hardsizes;	/* Hardware sector size */
  static int *sd_max_sectors;
--- 91,97 ----
  
  static Scsi_Disk *rscsi_disks;
  static struct gendisk *sd_gendisks;
! static sector_t *sd_sizes;
  static int *sd_blocksizes;
  static int *sd_hardsizes;	/* Hardware sector size */
  static int *sd_max_sectors;
***************
*** 232,238 ****
  
  			diskinfo[0] = 0x40;
  			diskinfo[1] = 0x20;
! 			diskinfo[2] = rscsi_disks[DEVICE_NR(dev)].capacity >> 11;
  
  			/* override with calculated, extended default, or driver values */
  
--- 232,238 ----
  
  			diskinfo[0] = 0x40;
  			diskinfo[1] = 0x20;
! 			diskinfo[2] = (int)rscsi_disks[DEVICE_NR(dev)].capacity >> 11;
  
  			/* override with calculated, extended default, or driver values */
  
***************
*** 308,314 ****
  
  static int sd_init_command(Scsi_Cmnd * SCpnt)
  {
! 	int dev, block, this_count;
  	struct hd_struct *ppnt;
  	Scsi_Disk *dpnt;
  #if CONFIG_SCSI_LOGGING
--- 308,315 ----
  
  static int sd_init_command(Scsi_Cmnd * SCpnt)
  {
! 	int dev, this_count;
! 	sector_t block;
  	struct hd_struct *ppnt;
  	Scsi_Disk *dpnt;
  #if CONFIG_SCSI_LOGGING
***************
*** 321,328 ****
  	block = SCpnt->request.sector;
  	this_count = SCpnt->request_bufflen >> 9;
  
! 	SCSI_LOG_HLQUEUE(1, printk("Doing sd request, dev = 0x%x, block = %d\n",
! 	    SCpnt->request.rq_dev, block));
  
  	dpnt = &rscsi_disks[dev];
  	if (dev >= sd_template.dev_max ||
--- 322,329 ----
  	block = SCpnt->request.sector;
  	this_count = SCpnt->request_bufflen >> 9;
  
! 	SCSI_LOG_HLQUEUE(1, printk("Doing sd request, dev = 0x%x, block = %llu\n",
! 				   SCpnt->request.rq_dev, (unsigned long long)block));
  
  	dpnt = &rscsi_disks[dev];
  	if (dev >= sd_template.dev_max ||
***************
*** 343,350 ****
  		return 0;
  	}
  	SCSI_LOG_HLQUEUE(2, sd_devname(dev, nbuff));
! 	SCSI_LOG_HLQUEUE(2, printk("%s : real dev = /dev/%d, block = %d\n",
! 				   nbuff, dev, block));
  
  	/*
  	 * If we have a 1K hardware sectorsize, prevent access to single
--- 344,351 ----
  		return 0;
  	}
  	SCSI_LOG_HLQUEUE(2, sd_devname(dev, nbuff));
! 	SCSI_LOG_HLQUEUE(2, printk("%s : real dev = /dev/%d, block = %llu\n",
! 				   nbuff, dev, (unsigned long long)block));
  
  	/*
  	 * If we have a 1K hardware sectorsize, prevent access to single
***************
*** 617,623 ****
  	int this_count = SCpnt->bufflen >> 9;
  	int good_sectors = (result == 0 ? this_count : 0);
  	int block_sectors = 1;
! 	long error_sector;
  
  	SCSI_LOG_HLCOMPLETE(1, sd_devname(DEVICE_NR(SCpnt->request.rq_dev), nbuff));
  
--- 618,624 ----
  	int this_count = SCpnt->bufflen >> 9;
  	int good_sectors = (result == 0 ? this_count : 0);
  	int block_sectors = 1;
! 	sector_t error_sector;
  
  	SCSI_LOG_HLCOMPLETE(1, sd_devname(DEVICE_NR(SCpnt->request.rq_dev), nbuff));
  
***************
*** 1003,1009 ****
  		 */
  		rscsi_disks[i].ready = 1;
  
! 		rscsi_disks[i].capacity = 1 + ((buffer[0] << 24) |
  					       (buffer[1] << 16) |
  					       (buffer[2] << 8) |
  					       buffer[3]);
--- 1004,1010 ----
  		 */
  		rscsi_disks[i].ready = 1;
  
! 		rscsi_disks[i].capacity = 1 + (((sector_t)buffer[0] << 24) |
  					       (buffer[1] << 16) |
  					       (buffer[2] << 8) |
  					       buffer[3]);
***************
*** 1051,1077 ****
  			 */
  			int m;
  			int hard_sector = sector_size;
! 			unsigned int sz = (rscsi_disks[i].capacity/2) * (hard_sector/256);
  
  			/* There are 16 minors allocated for each major device */
  			for (m = i << 4; m < ((i + 1) << 4); m++) {
  				sd_hardsizes[m] = hard_sector;
  			}
  
  			printk("SCSI device %s: "
! 			       "%u %d-byte hdwr sectors (%u MB)\n",
! 			       nbuff, rscsi_disks[i].capacity,
! 			       hard_sector, (sz - sz/625 + 974)/1950);
  		}
  
  		/* Rescale capacity to 512-byte units */
  		if (sector_size == 4096)
  			rscsi_disks[i].capacity <<= 3;
! 		if (sector_size == 2048)
  			rscsi_disks[i].capacity <<= 2;
! 		if (sector_size == 1024)
  			rscsi_disks[i].capacity <<= 1;
! 		if (sector_size == 256)
  			rscsi_disks[i].capacity >>= 1;
  	}
  
--- 1052,1084 ----
  			 */
  			int m;
  			int hard_sector = sector_size;
! 			sector_t sz = rscsi_disks[i].capacity * (hard_sector/256);
! 			sector_t mb;
  
  			/* There are 16 minors allocated for each major device */
  			for (m = i << 4; m < ((i + 1) << 4); m++) {
  				sd_hardsizes[m] = hard_sector;
  			}
+ 			mb = sz >> 1;
+ 			sector_div(sz, 1250);
+ 			mb -= (sz - 974);
+ 			sector_div(mb, 1950);
+ 
  
  			printk("SCSI device %s: "
! 			       "%llu %d-byte hdwr sectors (%llu MB)\n",
! 			       nbuff, (unsigned long long)rscsi_disks[i].capacity,
! 			       hard_sector, (unsigned long long)mb);
  		}
  
  		/* Rescale capacity to 512-byte units */
  		if (sector_size == 4096)
  			rscsi_disks[i].capacity <<= 3;
! 		else if (sector_size == 2048)
  			rscsi_disks[i].capacity <<= 2;
! 		else if (sector_size == 1024)
  			rscsi_disks[i].capacity <<= 1;
! 		else if (sector_size == 256)
  			rscsi_disks[i].capacity >>= 1;
  	}
  
***************
*** 1173,1192 ****
  	memset(rscsi_disks, 0, sd_template.dev_max * sizeof(Scsi_Disk));
  
  	/* for every (necessary) major: */
! 	sd_sizes = kmalloc((sd_template.dev_max << 4) * sizeof(int), GFP_ATOMIC);
  	if (!sd_sizes)
  		goto cleanup_disks;
! 	memset(sd_sizes, 0, (sd_template.dev_max << 4) * sizeof(int));
  
! 	sd_blocksizes = kmalloc((sd_template.dev_max << 4) * sizeof(int), GFP_ATOMIC);
  	if (!sd_blocksizes)
  		goto cleanup_sizes;
! 	
! 	sd_hardsizes = kmalloc((sd_template.dev_max << 4) * sizeof(int), GFP_ATOMIC);
  	if (!sd_hardsizes)
  		goto cleanup_blocksizes;
  
! 	sd_max_sectors = kmalloc((sd_template.dev_max << 4) * sizeof(int), GFP_ATOMIC);
  	if (!sd_max_sectors)
  		goto cleanup_max_sectors;
  
--- 1180,1199 ----
  	memset(rscsi_disks, 0, sd_template.dev_max * sizeof(Scsi_Disk));
  
  	/* for every (necessary) major: */
! 	sd_sizes = kmalloc((sd_template.dev_max << 4) * sizeof(*sd_sizes), GFP_ATOMIC);
  	if (!sd_sizes)
  		goto cleanup_disks;
! 	memset(sd_sizes, 0, (sd_template.dev_max << 4) * sizeof(*sd_sizes));
  
! 	sd_blocksizes = kmalloc((sd_template.dev_max << 4) * sizeof(*sd_blocksizes), GFP_ATOMIC);
  	if (!sd_blocksizes)
  		goto cleanup_sizes;
! 
! 	sd_hardsizes = kmalloc((sd_template.dev_max << 4) * sizeof(*sd_hardsizes), GFP_ATOMIC);
  	if (!sd_hardsizes)
  		goto cleanup_blocksizes;
  
! 	sd_max_sectors = kmalloc((sd_template.dev_max << 4) * sizeof(*sd_max_sectors), GFP_ATOMIC);
  	if (!sd_max_sectors)
  		goto cleanup_max_sectors;
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/sd.h linux-2.4.22-ashuariadevel/drivers/scsi/sd.h
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/sd.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/sd.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 25,31 ****
  
  typedef struct scsi_disk {
  	Scsi_Device *device;
! 	unsigned capacity;		/* size in blocks */
  	unsigned char sector_bit_size;	/* sector_size = 2 to the bit size power */
  	unsigned char sector_bit_shift;	/* power of 2 sectors per FS block */
  	unsigned has_part_table:1;	/* has partition table */
--- 25,31 ----
  
  typedef struct scsi_disk {
  	Scsi_Device *device;
! 	sector_t capacity;		/* size in blocks */
  	unsigned char sector_bit_size;	/* sector_size = 2 to the bit size power */
  	unsigned char sector_bit_shift;	/* power of 2 sectors per FS block */
  	unsigned has_part_table:1;	/* has partition table */
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/sr.c linux-2.4.22-ashuariadevel/drivers/scsi/sr.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/sr.c	2003-06-13 23:51:36.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/sr.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 85,91 ****
  };
  
  Scsi_CD *scsi_CDs;
! static int *sr_sizes;
  
  static int *sr_blocksizes;
  static int *sr_hardsizes;
--- 85,91 ----
  };
  
  Scsi_CD *scsi_CDs;
! static sector_t *sr_sizes;
  
  static int *sr_blocksizes;
  static int *sr_hardsizes;
***************
*** 198,204 ****
  	int good_sectors = (result == 0 ? this_count : 0);
  	int block_sectors = 0;
  	int device_nr = DEVICE_NR(SCpnt->request.rq_dev);
! 	long error_sector;
  
  #ifdef DEBUG
  	printk("sr.c done: %x %p\n", result, SCpnt->request.bh->b_data);
--- 198,204 ----
  	int good_sectors = (result == 0 ? this_count : 0);
  	int block_sectors = 0;
  	int device_nr = DEVICE_NR(SCpnt->request.rq_dev);
! 	sector_t error_sector;
  
  #ifdef DEBUG
  	printk("sr.c done: %x %p\n", result, SCpnt->request.bh->b_data);
***************
*** 295,301 ****
  	/*
  	 * need front pad
  	 */
! 	if ((fsize = SCpnt->request.sector % (s_size >> 9))) {
  		fsize <<= 9;
  		sg_ent++;
  		if ((front = scsi_malloc(fsize)) == NULL)
--- 295,301 ----
  	/*
  	 * need front pad
  	 */
! 	if ((fsize = (unsigned long)SCpnt->request.sector % (s_size >> 9))) {
  		fsize <<= 9;
  		sg_ent++;
  		if ((front = scsi_malloc(fsize)) == NULL)
***************
*** 427,438 ****
  		return 0;
  	}
  
! 	block = SCpnt->request.sector / (s_size >> 9);
  
  	/*
  	 * request doesn't start on hw block boundary, add scatter pads
  	 */
! 	if ((SCpnt->request.sector % (s_size >> 9)) || (SCpnt->request_bufflen % s_size))
  		if (sr_scatter_pad(SCpnt, s_size))
  			return 0;
  
--- 427,438 ----
  		return 0;
  	}
  
! 	block = (long)SCpnt->request.sector / (s_size >> 9);
  
  	/*
  	 * request doesn't start on hw block boundary, add scatter pads
  	 */
! 	if (((long)SCpnt->request.sector % (s_size >> 9)) || (SCpnt->request_bufflen % s_size))
  		if (sr_scatter_pad(SCpnt, s_size))
  			return 0;
  
***************
*** 826,841 ****
  		goto cleanup_devfs;
  	memset(scsi_CDs, 0, sr_template.dev_max * sizeof(Scsi_CD));
  
! 	sr_sizes = kmalloc(sr_template.dev_max * sizeof(int), GFP_ATOMIC);
  	if (!sr_sizes)
  		goto cleanup_cds;
! 	memset(sr_sizes, 0, sr_template.dev_max * sizeof(int));
  
! 	sr_blocksizes = kmalloc(sr_template.dev_max * sizeof(int), GFP_ATOMIC);
  	if (!sr_blocksizes)
  		goto cleanup_sizes;
  
! 	sr_hardsizes = kmalloc(sr_template.dev_max * sizeof(int), GFP_ATOMIC);
  	if (!sr_hardsizes)
  		goto cleanup_blocksizes;
  	/*
--- 826,841 ----
  		goto cleanup_devfs;
  	memset(scsi_CDs, 0, sr_template.dev_max * sizeof(Scsi_CD));
  
! 	sr_sizes = kmalloc(sr_template.dev_max * sizeof(sr_sizes[0]), GFP_ATOMIC);
  	if (!sr_sizes)
  		goto cleanup_cds;
! 	memset(sr_sizes, 0, sr_template.dev_max * sizeof(sr_sizes[0]));
  
! 	sr_blocksizes = kmalloc(sr_template.dev_max * sizeof(sr_blocksizes[0]), GFP_ATOMIC);
  	if (!sr_blocksizes)
  		goto cleanup_sizes;
  
! 	sr_hardsizes = kmalloc(sr_template.dev_max * sizeof(sr_hardsizes[0]), GFP_ATOMIC);
  	if (!sr_hardsizes)
  		goto cleanup_blocksizes;
  	/*
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/sym53c8xx_2/sym_glue.c linux-2.4.22-ashuariadevel/drivers/scsi/sym53c8xx_2/sym_glue.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/sym53c8xx_2/sym_glue.c	2002-11-29 08:53:14.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/sym53c8xx_2/sym_glue.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1879,1887 ****
  		goto out_err32;
  #else
  #if   SYM_CONF_DMA_ADDRESSING_MODE == 1
! #define	PciDmaMask	0xffffffffff
  #elif SYM_CONF_DMA_ADDRESSING_MODE == 2
! #define	PciDmaMask	0xffffffffffffffff
  #endif
  	if (np->features & FE_DAC) {
  		if (!pci_set_dma_mask(np->s.device, PciDmaMask)) {
--- 1879,1887 ----
  		goto out_err32;
  #else
  #if   SYM_CONF_DMA_ADDRESSING_MODE == 1
! #define	PciDmaMask	0xffffffffffULL
  #elif SYM_CONF_DMA_ADDRESSING_MODE == 2
! #define	PciDmaMask	0xffffffffffffffffULL
  #endif
  	if (np->features & FE_DAC) {
  		if (!pci_set_dma_mask(np->s.device, PciDmaMask)) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/wd7000.c linux-2.4.22-ashuariadevel/drivers/scsi/wd7000.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/wd7000.c	2001-10-01 04:26:08.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/wd7000.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1739,1745 ****
       */
      ip[0] = 64;
      ip[1] = 32;
!     ip[2] = disk->capacity / (64 * 32);
  
      /*
       * for disks >1GB do some guessing
--- 1739,1745 ----
       */
      ip[0] = 64;
      ip[1] = 32;
!     ip[2] = (long)disk->capacity / (64 * 32);
  
      /*
       * for disks >1GB do some guessing
***************
*** 1758,1764 ****
  
  	    ip[0] = 255;
  	    ip[1] = 63;
! 	    ip[2] = disk->capacity / (255 * 63);
  	}
  	else {
  	    ip[0] = info[0];
--- 1758,1764 ----
  
  	    ip[0] = 255;
  	    ip[1] = 63;
! 	    ip[2] = (long)disk->capacity / (255 * 63);
  	}
  	else {
  	    ip[0] = info[0];
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/adfs/adfs.h linux-2.4.22-ashuariadevel/fs/adfs/adfs.h
*** linux-2.4.22-ashuariadevel.backup/fs/adfs/adfs.h	2000-09-19 07:14:06.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/adfs/adfs.h	2004-02-02 14:35:09.000000000 +0900
***************
*** 66,72 ****
  
  /* Inode stuff */
  #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,0)
! int adfs_get_block(struct inode *inode, long block,
  		   struct buffer_head *bh, int create);
  #else
  int adfs_bmap(struct inode *inode, int block);
--- 66,72 ----
  
  /* Inode stuff */
  #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,0)
! int adfs_get_block(struct inode *inode, sector_t block,
  		   struct buffer_head *bh, int create);
  #else
  int adfs_bmap(struct inode *inode, int block);
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/adfs/inode.c linux-2.4.22-ashuariadevel/fs/adfs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/adfs/inode.c	2001-10-01 04:26:08.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/adfs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 27,33 ****
   * not support creation of new blocks, so we return -EIO for this case.
   */
  int
! adfs_get_block(struct inode *inode, long block, struct buffer_head *bh, int create)
  {
  	if (block < 0)
  		goto abort_negative;
--- 27,33 ----
   * not support creation of new blocks, so we return -EIO for this case.
   */
  int
! adfs_get_block(struct inode *inode, sector_t block, struct buffer_head *bh, int create)
  {
  	if (block < 0)
  		goto abort_negative;
***************
*** 71,77 ****
  		&page->mapping->host->u.adfs_i.mmu_private);
  }
  
! static int _adfs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping, block, adfs_get_block);
  }
--- 71,77 ----
  		&page->mapping->host->u.adfs_i.mmu_private);
  }
  
! static sector_t _adfs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping, block, adfs_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/affs/file.c linux-2.4.22-ashuariadevel/fs/affs/file.c
*** linux-2.4.22-ashuariadevel.backup/fs/affs/file.c	2002-02-26 04:38:07.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/affs/file.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 38,44 ****
  static struct buffer_head *affs_alloc_extblock(struct inode *inode, struct buffer_head *bh, u32 ext);
  static inline struct buffer_head *affs_get_extblock(struct inode *inode, u32 ext);
  static struct buffer_head *affs_get_extblock_slow(struct inode *inode, u32 ext);
! static int affs_get_block(struct inode *inode, long block, struct buffer_head *bh_result, int create);
  
  static ssize_t affs_file_write(struct file *filp, const char *buf, size_t count, loff_t *ppos);
  static int affs_file_open(struct inode *inode, struct file *filp);
--- 38,44 ----
  static struct buffer_head *affs_alloc_extblock(struct inode *inode, struct buffer_head *bh, u32 ext);
  static inline struct buffer_head *affs_get_extblock(struct inode *inode, u32 ext);
  static struct buffer_head *affs_get_extblock_slow(struct inode *inode, u32 ext);
! static int affs_get_block(struct inode *inode, sector_t block, struct buffer_head *bh_result, int create);
  
  static ssize_t affs_file_write(struct file *filp, const char *buf, size_t count, loff_t *ppos);
  static int affs_file_open(struct inode *inode, struct file *filp);
***************
*** 332,348 ****
  }
  
  static int
! affs_get_block(struct inode *inode, long block, struct buffer_head *bh_result, int create)
  {
  	struct super_block	*sb = inode->i_sb;
  	struct buffer_head	*ext_bh;
  	u32			 ext;
  
! 	pr_debug("AFFS: get_block(%u, %ld)\n", (u32)inode->i_ino, block);
  
  	if (block < 0)
  		goto err_small;
  
  	if (block >= AFFS_INODE->i_blkcnt) {
  		if (block > AFFS_INODE->i_blkcnt || !create)
  			goto err_big;
--- 332,352 ----
  }
  
  static int
! affs_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create)
  {
  	struct super_block	*sb = inode->i_sb;
  	struct buffer_head	*ext_bh;
+ 	long			 block = iblock;
  	u32			 ext;
  
! 	pr_debug("AFFS: get_block(%u, %ld)\n", (u32)inode->i_ino, (long)block);
  
  	if (block < 0)
  		goto err_small;
  
+ 	if (unlikely(iblock != block))
+ 		goto err_big;
+ 
  	if (block >= AFFS_INODE->i_blkcnt) {
  		if (block > AFFS_INODE->i_blkcnt || !create)
  			goto err_big;
***************
*** 423,429 ****
  	return cont_prepare_write(page, from, to, affs_get_block,
  		&page->mapping->host->u.affs_i.mmu_private);
  }
! static int _affs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,affs_get_block);
  }
--- 427,433 ----
  	return cont_prepare_write(page, from, to, affs_get_block,
  		&page->mapping->host->u.affs_i.mmu_private);
  }
! static sector_t _affs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,affs_get_block);
  }
***************
*** 433,439 ****
  	sync_page: block_sync_page,
  	prepare_write: affs_prepare_write,
  	commit_write: generic_commit_write,
! 	bmap: _affs_bmap
  };
  
  static inline struct buffer_head *
--- 437,443 ----
  	sync_page: block_sync_page,
  	prepare_write: affs_prepare_write,
  	commit_write: generic_commit_write,
! 	bmap: _affs_bmap,
  };
  
  static inline struct buffer_head *
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/affs/inode.c linux-2.4.22-ashuariadevel/fs/affs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/affs/inode.c	2002-02-26 04:38:07.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/affs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 395,400 ****
--- 395,404 ----
  	}
  	affs_fix_checksum(sb, bh);
  	mark_buffer_dirty_inode(bh, inode);
+ 	/*
+ 	 * You'll get a warning here if CONFIG_LBD because blocknr is 64 bits.
+ 	 * AFS isn't supported on partitions over 2Tb
+ 	 */
  	dentry->d_fsdata = (void *)bh->b_blocknr;
  
  	affs_lock_dir(dir);
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/affs/super.c linux-2.4.22-ashuariadevel/fs/affs/super.c
*** linux-2.4.22-ashuariadevel.backup/fs/affs/super.c	2002-02-26 04:38:07.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/affs/super.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 29,35 ****
  #include <asm/system.h>
  #include <asm/uaccess.h>
  
- extern int *blk_size[];
  extern struct timezone sys_tz;
  
  static int affs_statfs(struct super_block *sb, struct statfs *buf);
--- 29,34 ----
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/befs/btree.c linux-2.4.22-ashuariadevel/fs/befs/btree.c
*** linux-2.4.22-ashuariadevel.backup/fs/befs/btree.c	2003-06-13 23:51:37.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/befs/btree.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 85,91 ****
  } befs_btree_node;
  
  /* local constants */
! const static befs_off_t befs_bt_inval = 0xffffffffffffffff;
  
  /* local functions */
  static int befs_btree_seekleaf(struct super_block *sb, befs_data_stream * ds,
--- 85,91 ----
  } befs_btree_node;
  
  /* local constants */
! const static befs_off_t befs_bt_inval = 0xffffffffffffffffULL;
  
  /* local functions */
  static int befs_btree_seekleaf(struct super_block *sb, befs_data_stream * ds,
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/befs/linuxvfs.c linux-2.4.22-ashuariadevel/fs/befs/linuxvfs.c
*** linux-2.4.22-ashuariadevel.backup/fs/befs/linuxvfs.c	2003-06-13 23:51:37.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/befs/linuxvfs.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 32,40 ****
  #define VFS_BLOCK_SIZE 512
  
  static int befs_readdir(struct file *, void *, filldir_t);
! static int befs_get_block(struct inode *, long, struct buffer_head *, int);
  static int befs_readpage(struct file *file, struct page *page);
! static int befs_bmap(struct address_space *mapping, long block);
  static struct dentry *befs_lookup(struct inode *, struct dentry *);
  static void befs_read_inode(struct inode *ino);
  static void befs_clear_inode(struct inode *ino);
--- 32,40 ----
  #define VFS_BLOCK_SIZE 512
  
  static int befs_readdir(struct file *, void *, filldir_t);
! static int befs_get_block(struct inode *, sector_t, struct buffer_head *, int);
  static int befs_readpage(struct file *file, struct page *page);
! static sector_t befs_bmap(struct address_space *mapping, sector_t block);
  static struct dentry *befs_lookup(struct inode *, struct dentry *);
  static void befs_read_inode(struct inode *ino);
  static void befs_clear_inode(struct inode *ino);
***************
*** 115,122 ****
  	return block_read_full_page(page, befs_get_block);
  }
  
! static int
! befs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping, block, befs_get_block);
  }
--- 115,122 ----
  	return block_read_full_page(page, befs_get_block);
  }
  
! static sector_t
! befs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping, block, befs_get_block);
  }
***************
*** 133,139 ****
   */
  
  static int
! befs_get_block(struct inode *inode, long block,
  	       struct buffer_head *bh_result, int create)
  {
  	struct super_block *sb = inode->i_sb;
--- 133,139 ----
   */
  
  static int
! befs_get_block(struct inode *inode, sector_t sect,
  	       struct buffer_head *bh_result, int create)
  {
  	struct super_block *sb = inode->i_sb;
***************
*** 141,146 ****
--- 141,147 ----
  	befs_block_run run = BAD_IADDR;
  	int res = 0;
  	ulong disk_off;
+ 	long block = (unsigned long)sect;
  
  	befs_debug(sb, "---> befs_get_block() for inode %lu, block %ld",
  		   inode->i_ino, block);
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/bfs/file.c linux-2.4.22-ashuariadevel/fs/bfs/file.c
*** linux-2.4.22-ashuariadevel.backup/fs/bfs/file.c	2001-08-13 02:56:56.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/bfs/file.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 54,60 ****
  	return 0;
  }
  
! static int bfs_get_block(struct inode * inode, long block, 
  	struct buffer_head * bh_result, int create)
  {
  	long phys;
--- 54,60 ----
  	return 0;
  }
  
! static int bfs_get_block(struct inode * inode, sector_t block, 
  	struct buffer_head * bh_result, int create)
  {
  	long phys;
***************
*** 151,157 ****
  	return block_prepare_write(page, from, to, bfs_get_block);
  }
  
! static int bfs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping, block, bfs_get_block);
  }
--- 151,157 ----
  	return block_prepare_write(page, from, to, bfs_get_block);
  }
  
! static sector_t bfs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping, block, bfs_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/block_dev.c linux-2.4.22-ashuariadevel/fs/block_dev.c
*** linux-2.4.22-ashuariadevel.backup/fs/block_dev.c	2003-06-13 23:51:37.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/block_dev.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 22,35 ****
  
  #include <asm/uaccess.h>
  
! static unsigned long max_block(kdev_t dev)
  {
! 	unsigned int retval = ~0U;
  	int major = MAJOR(dev);
  
  	if (blk_size[major]) {
  		int minor = MINOR(dev);
! 		unsigned int blocks = blk_size[major][minor];
  		if (blocks) {
  			unsigned int size = block_size(dev);
  			unsigned int sizebits = blksize_bits(size);
--- 22,35 ----
  
  #include <asm/uaccess.h>
  
! static sector_t max_block(kdev_t dev)
  {
! 	sector_t retval = ~0;
  	int major = MAJOR(dev);
  
  	if (blk_size[major]) {
  		int minor = MINOR(dev);
! 		sector_t blocks = blk_size[major][minor];
  		if (blocks) {
  			unsigned int size = block_size(dev);
  			unsigned int sizebits = blksize_bits(size);
***************
*** 44,50 ****
  
  static loff_t blkdev_size(kdev_t dev)
  {
! 	unsigned int blocks = ~0U;
  	int major = MAJOR(dev);
  
  	if (blk_size[major]) {
--- 44,50 ----
  
  static loff_t blkdev_size(kdev_t dev)
  {
! 	sector_t blocks = ~0;
  	int major = MAJOR(dev);
  
  	if (blk_size[major]) {
***************
*** 120,126 ****
  	return sb_set_blocksize(sb, size);
  }
  
! static int blkdev_get_block(struct inode * inode, long iblock, struct buffer_head * bh, int create)
  {
  	if (iblock >= max_block(inode->i_rdev))
  		return -EIO;
--- 120,126 ----
  	return sb_set_blocksize(sb, size);
  }
  
! static int blkdev_get_block(struct inode * inode, sector_t iblock, struct buffer_head * bh, int create)
  {
  	if (iblock >= max_block(inode->i_rdev))
  		return -EIO;
***************
*** 131,137 ****
  	return 0;
  }
  
! static int blkdev_direct_IO(int rw, struct inode * inode, struct kiobuf * iobuf, unsigned long blocknr, int blocksize)
  {
  	return generic_direct_IO(rw, inode, iobuf, blocknr, blocksize, blkdev_get_block);
  }
--- 131,137 ----
  	return 0;
  }
  
! static int blkdev_direct_IO(int rw, struct inode * inode, struct kiobuf * iobuf, sector_t blocknr, int blocksize)
  {
  	return generic_direct_IO(rw, inode, iobuf, blocknr, blocksize, blkdev_get_block);
  }
